/*******************************************************************************

    FILE:    cs_dummy.c
    AUTHOR: R. Cooper
    CREATION DATE: 
    CONTENTS: 

*******************************************************************************/

#include "ss.h"

#undef DEFBUG

#ifdef DEBUG
extern void list_schema_activation(ContentionScheduler *cs, Schema *this);
extern void list_object_activation(ContentionScheduler *cs, Object *this, ObjectRole role);
extern void list_effector_activation(ContentionScheduler *cs, Effector *this);
#endif
/*----------------------------------------------------------------------------*/

void record_schema_activity(ContentionScheduler *cs, char *name, Boolean selected, double before, double s, double l, double p, double e, double in, double after, char *note)
{
    fprintf(stdout, "%d: %s: %3.5f + %3.5f + %3.5f + %3.5f => %6.4f\n", cs->cycle, name, s, l, p, e, after);
}

void record_object_activity(ContentionScheduler *cs, char *name, int r, Boolean selected, double before, double s, double l, double p, double e, double in, double after, char *note)
{
    fprintf(stdout, "%d: %s (%d): %3.5f + %3.5f + %3.5f + %3.5f => %6.4f\n", cs->cycle, name, r, s, l, p, e, after);
}

void record_effector_activity(ContentionScheduler *cs, char *name, Boolean selected, double before, double s, double l, double p, double e, double in, double after, char *note)
{
    fprintf(stdout, "%d: %s: %3.5f + %3.5f + %3.5f + %3.5f => %6.4f\n", cs->cycle, name, s, l, p, e, after);
}

void dump_activations(ContentionScheduler *cs)
{
#ifdef DEBUG
    SchemaList *sl;
    ObjectList *ol;
    EffectorList *el;
    int i;

    for (sl = cs->schemas; sl != NULL; sl = sl->tail) {
        list_schema_activation(cs, sl->head);
    }
    for (i = 0; i < MAX_ROLES; i++) {
        for (ol = cs->objects; ol != NULL; ol = ol->tail) {
            list_object_activation(cs, ol->head, i);
        }
    }

    for (el = cs->effectors; el != NULL; el = el->tail) {
        list_effector_activation(cs, el->head);
    }
#endif
}

/******************************************************************************/

void analyse_null_task() {}
void analyse_wcst_task() {}
void analyse_tol_task() {}
void analyse_rng_task() {}

/******************************************************************************/

void message(MessageType m, ContentionScheduler *cs, char *string)
{
    if (messages[m] != NULL) {
        fprintf(messages[m], "%5d\t%s\n", cs->cycle, string);
    }
}

/******************************************************************************/
