/*******************************************************************************

    File:     ss_temporary_schema.c
    Author:   Rick Cooper
    Created:  22/05/07
    Edited:   22/05/07
    Contents: Routines maintaining the temporary schema that guides behaviour.

    Public procedures:

*******************************************************************************/

#include "ss.h"


void temporary_schema_reject_current(ContentionScheduler *cs)
{
    if (cs->temporary_schema != NULL) {
        free(cs->temporary_schema);
        cs->temporary_schema = NULL;
    }
}

char *temporary_schema_get(ContentionScheduler *cs)
{
    return(cs->temporary_schema);
}

void temporary_schema_set(ContentionScheduler *cs, char *s)
{
    if (cs->temporary_schema != NULL) {
        free(cs->temporary_schema);
    }
    cs->temporary_schema = string_copy(s);
}


