/*******************************************************************************

    File:     tol_effector.c
    Author:   Rick Cooper
    Created:  30/03/07
    Edited:   30/03/07
    Contents: Create/maintain effectors for the ToL task

    Public procedures:
        void install_tol_effectors(ContentionScheduler *cs)
        void write_tol_effector_attributes(FILE *fp, Effector *effector)

*******************************************************************************/

#include "ss.h"
#include "tol.h"

/******************************************************************************/
/* Section 1: Install effectors ----------------------------------------------*/

void install_tol_effectors(ContentionScheduler *cs)
{
    effectorInstall(cs, "leftHand");
    effectorInstall(cs, "rightHand");
}

/******************************************************************************/
/* Section 2: Write effector attributes (for debugging) ----------------------*/

void write_tol_effector_attributes(FILE *fp, Effector *effector)
{
    ObjectList *os;

    if (effector->itemsHeld) {
	fprintf(fp, "holds");
	for (os = effector->itemsHeld; os; os = os->tail) {
	    if (os->tail) {
		fprintf(fp, " %s,", os->head->name);
	    }
	    else {
		fprintf(fp, " %s", os->head->name);
	    }
	}
    }
    else {
	fprintf(fp, "empty");
    }
}

/******************************************************************************/
