
#define CRITERION 10
#define NUM_CARDS 64

typedef enum criterion  {SORT_NULL, SORT_COLOUR, SORT_FORM, SORT_NUMBER} Criterion;

typedef struct card {
    int number;
    int colour;
    int form;
    int position_x;
    int position_y;
} Card;

typedef struct wcst_task_data {
    int       event_count;
    int       trial_count;
    Card      card_target[4];
    Card      card_sorted[4];
    Card      card_list[NUM_CARDS];
    Criterion criterion;
    int       correct_consecutive_sorts;
    Card      current_card;
    int       chosen_deck;
    char     *feedback;
    Boolean   trial_complete;
    int       features_matched[NUM_CARDS];
    Boolean   correct[NUM_CARDS];
    Boolean   perseverative_error[NUM_CARDS];
    /* Scoring: */
    int       score_total_correct_sorts;
    int       score_categories_obtained;
    int       score_errors_perseverations;
    int       score_errors_ppr;
    int       score_errors_ppc;
    int       score_errors_set_loss;
    int       score_errors_other;
} WcstTaskData;

/* Defined in wcst.c: --------------------------------------------------------*/

extern WcstTaskData *wcst_create_task();
extern void wcst_destroy_task(WcstTaskData *task);
extern void wcst_initialise_task(WcstTaskData *task);
extern void wcst_initialise_next_trial(ContentionScheduler *cs, WcstTaskData *task);
extern Boolean wcst_trial_complete(WcstTaskData *task);
extern Boolean wcst_task_complete(WcstTaskData *task);
extern void wcst_step_event(ContentionScheduler *cs, WcstTaskData *task);
extern void wcst_synchronise_world(ContentionScheduler *cs, WcstTaskData *task);
extern void wcst_action_pick_up(WcstTaskData *task, Object *theme, Effector *effector);
extern void wcst_action_put_down(WcstTaskData *task, Object *theme, Object *target);
extern void wcst_dump_analyses(FILE *fp, WcstTaskData *task);

/******************************************************************************/

extern void wcst_initialise_wm(ContentionScheduler *cs);
